/* $Header: /usr2/brugere/jbln/uc133/src/RCS/cfgfile.c,v 1.3 1995/02/24 02:13:54 jbln Exp $ */

#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <ctype.h>

#include "uc.h"
#include "cfgfile.h"


static int cfg_lineno;

/************************************************************
   INIFILE EDITING
************************************************************/

/* ===[ READ AN INIFILE ]=========================================== */
CFGDATA *cfg_readfile(fname, num)
char *fname;
int *num;
{
   CFGDATA *cfg = NULL;
   int cfgnum=0;
   FILE *ifile;
   char buf[400], *p, *rem;

   if ( (ifile=fopen(fname, "r")) == NULL )
      return(NULL);
   cfg_lineno = 0;

   while (fgets(buf, 400, ifile) != NULL)
   {
      cfg_lineno++;
      while (buf[strlen(buf)-1] == '\n')
	 buf[strlen(buf)-1] = 0;

      rem = NULL;

      p = buf;

      while (isspace(*p)  &&  *p!='\n')
	 p++;

      if (*p!='\n'  &&  *p!=';'  &&  *p!=0)
      {
	 if (*p == '[')
	    cfg_parseheader(p, &cfg, &cfgnum);
	 else
	    cfg_parsedata(p, &cfg[cfgnum-1], rem);
      }
   }

   fclose(ifile);

   *num = cfgnum;
   return(cfg);
}


cfg_parseheader(line, cfg, num)
char *line;
CFGDATA **cfg;
int *num;
{
   char *p = line+1;

   while (*p != ']')
      p++;

   *p = 0;

   cfg_newheader(cfg, num, &line[1]);
}


cfg_parsedata(line, cfg, rem)
char *line;
CFGDATA *cfg;
char *rem;
{
   char *p=line, c;
   char *id, *val;


   while (!isspace(*p)  &&  *p!='=')
      p++;
   if (*p == 0)
      return(0);
   c = *p;
   *p = 0;

   id = strdup(line);
   *p = c;
   if (*p != '=')
      p++;

   while (isspace(*p)  &&  *p!='=')
      p++;
   if (*p != '=')
   {
      free(id);
      return(0);
   }
   p++;
   while (isspace(*p))
      p++;

   val = strdup(p);

   if (cfg->datanum == 0)
      cfg->data = (CFGLINE *)malloc(sizeof(CFGLINE));
   else
      cfg->data = (CFGLINE *)realloc(cfg->data, sizeof(CFGLINE)*(cfg->datanum+1));
   cfg->data[cfg->datanum].id = id;
   cfg->data[cfg->datanum].val = val;
   if (rem != NULL)
      cfg->data[cfg->datanum].rem = strdup(rem);
   else
      cfg->data[cfg->datanum].rem = NULL;
   cfg->datanum++;

   return(1);
}


cfg_newheader(cfg, num, name)
CFGDATA **cfg;
int *num;
char *name;
{
   if (*num == 0)
      *cfg = (CFGDATA *)malloc(sizeof(CFGDATA));
   else
      *cfg = (CFGDATA *)realloc(*cfg, (*num+1)*sizeof(CFGDATA));
   
   (*cfg)[*num].header = strdup(name);
   (*cfg)[*num].data = (CFGLINE *)NULL;
   (*cfg)[*num].datanum = 0;
   *num += 1;
}


/* ===[ CLEAR AN INIFILESTRUCTURE ]================================= */
cfg_clear(cfg, num)
CFGDATA *cfg;
int num;
{
   int m,n;

   for (n=0 ; n<num ; n++)
   {
      for (m=0 ; m<cfg[n].datanum ; m++)
      {
	 free(cfg[n].data[m].id);
	 free(cfg[n].data[m].val);
	 if (cfg[n].data[m].rem != NULL)
	    free(cfg[n].data[m].rem);
      }
      free(cfg[n].data);
   }
   free(cfg);
}


/* ===[ UPDATE AN INIFILE ]========================================= */
cfg_update(fname, header, id, val, num)
char *fname, *header;
char **id, **val;
int num;
{
   char tfname[200], *buf, *p, *h, c;
   FILE *ifile, *ofile;
   int headfound=0, idfound, setofpos=0, n;
   int makenewheader=1, more;
   int *allfoundid, allfound, dowritebuf;
   long ofpos, ifpos;

   if ( (ifile=fopen(fname,"r")) == NULL )
      return(0);

   if ( (buf=(char *)malloc(500)) == NULL )
   {
      fclose(ifile);
      return(0);
   }

   tmpnam(tfname);
   if ( (ofile=fopen(tfname,"w")) == NULL )
   {
      free(buf);
      fclose(ifile);
      return(0);
   }

   if ( (allfoundid=(int *)malloc(sizeof(int)*num)) == NULL )
   {
      free(buf);
      fclose(ifile);
      fclose(ofile);
      return(0);
   }
   memset(allfoundid, 0, sizeof(int)*num);

   do
   {
      more = (fgets(buf,500,ifile) != NULL);
      if (!more)
	 buf[0] = 0;
      p = buf;
      dowritebuf = 1;

      while (isspace(*p)  &&  *p!='\n')
	 p++;

      if (*p!='\n'  &&  *p!=';'  &&  *p!=0  ||  !more)
      {
	 if (*p == '['  ||  !more)
	 {
	    if (more)
	       p++;
	    h = p;
	    while (*p!=']'  &&  *p!=0  &&  *p!='\n')
	       p++;
	    c = *p;
	    *p = 0;

	    allfound=1;
	    if (headfound)	/* Test if all id's are found */
	    {
	       for (n=0, allfound=1 ; n<num ; n++)
		  if (!allfoundid[n])
		     allfound = 0;

	       if (!allfound)
	       {
		  n=fseek(ofile, ofpos, SEEK_SET);
		  n=fseek(ifile, ifpos, SEEK_SET);
		  more = 1;
		  dowritebuf = 0;
		  for (n=0 ; n<num ; n++)
		  {
		     if (!allfoundid[n])
		     {
			fprintf(ofile, "%s = %s\n", id[n], val[n]);
			allfoundid[n] = 1;
		     }
		  }
	       }
	    }

	    if (allfound  &&  more)
	    {
	       if (strcmp(h, header) == 0)
	       {
		  headfound = 1;
		  makenewheader = 0;
		  ifpos = ftell(ifile);
		  setofpos = 1;
	       }
	       else
		  headfound = 0;
	       *p = c;
	    }
	 }
	 else
	 {
	    while (!isspace(*p)  &&  *p!='=')
	       p++;
	    c = *p;
	    *p = 0;

	    for (n=0, idfound=0 ; n<num && !idfound ; n++)
	    {
	       if (strcmp(buf, id[n])==0  &&  headfound)
	       {
		  sprintf(buf, "%s = %s\n", id[n], val[n]);
		  idfound = 1;
		  allfoundid[n] = 1;
	       }
	    }
	    if (!idfound)
	       *p = c;
	 }
      }

      if (dowritebuf)
	 fputs(buf, ofile);

      if (setofpos)
      {
	 ofpos = ftell(ofile);
	 setofpos = 0;
      }
   }
   while (more);

   if (makenewheader)
   {
      fprintf(ofile, "\n[%s]\n", header);
      for (n=0 ; n<num ; n++)
	 fprintf(ofile, "%s = %s\n", id[n], val[n]);
   }

   fclose(ifile);
   fclose(ofile);

   if ( (ifile=fopen(tfname,"r")) == NULL )
   {
      unlink(tfname);
      return(0);
   }

   if ( (ofile=fopen(fname,"w")) == NULL )
   {
      fclose(ifile);
      unlink(tfname);
      return(0);
   }

   while (fgets(buf,500,ifile) != NULL)
      fputs(buf, ofile);

   free(buf);
   free(allfoundid);
   fclose(ifile);
   fclose(ofile);
   unlink(tfname);

   return(1);
}

