/* $Header: /usr2/brugere/jbln/uc133/src/RCS/sorting.c,v 1.3 1995/02/23 09:30:57 jbln Exp $ */

#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include "uc.h"


/************************************************************
   SORTING
************************************************************/

sort_cmpspec(f1, f2)
void *f1, *f2;
{
   if ( ((FILEINFO *)f1)->type == FTYPE_DIR  &&
        ((FILEINFO *)f2)->type != FTYPE_DIR )
      return(-1);
   if ( ((FILEINFO *)f1)->type != FTYPE_DIR  &&
        ((FILEINFO *)f2)->type == FTYPE_DIR )
      return(1);

   if ( ((FILEINFO *)f1)->type == FTYPE_DEV   &&
        ((FILEINFO *)f2)->type != FTYPE_DEV )
      return(-1);
   if ( ((FILEINFO *)f1)->type != FTYPE_DEV  &&
        ((FILEINFO *)f2)->type == FTYPE_DEV )
      return(1);

   if ( ((FILEINFO *)f1)->type == FTYPE_FIFO  &&
        ((FILEINFO *)f2)->type != FTYPE_FIFO )
      return(-1);
   if ( ((FILEINFO *)f1)->type != FTYPE_FIFO  &&
        ((FILEINFO *)f2)->type == FTYPE_FIFO )
      return(1);

   if ( ((FILEINFO *)f1)->type == FTYPE_OTHER  &&
        ((FILEINFO *)f2)->type != FTYPE_OTHER )
      return(-1);
   if ( ((FILEINFO *)f1)->type != FTYPE_OTHER  &&
        ((FILEINFO *)f2)->type == FTYPE_OTHER )
      return(1);

   return(0);
}


sort_byname(f1, f2)
void *f1, *f2;
{
   int a;

   if ((a=sort_cmpspec(f1,f2)) != 0)
      return(a);

   return(strcmp( ((FILEINFO *)f1)->name, ((FILEINFO *)f2)->name) );
}


sort_bysize(f1, f2)
void *f1, *f2;
{
   int a;

   if ((a=sort_cmpspec(f1,f2)) != 0)
      return(a);

   if ( ((FILEINFO *)f1)->type == FTYPE_DIR  &&
        ((FILEINFO *)f2)->type == FTYPE_DIR )
      return(sort_byname(f1,f2));

   if ( ((FILEINFO *)f1)->size == ((FILEINFO *)f2)->size )
      return(sort_byname(f1,f2));
   if( ((FILEINFO *)f1)->size > ((FILEINFO *)f2)->size )
      return(-1);
   else
      return(1);
}


sort_byext(f1, f2)
void *f1, *f2;
{
   char *name1, *name2;
   char *p1, *p2;
   int a;

   if ((a=sort_cmpspec(f1,f2)) != 0)
      return(a);

   if ( ((FILEINFO *)f1)->type == FTYPE_DIR  &&
        ((FILEINFO *)f2)->type == FTYPE_DIR )
      return(sort_byname(f1,f2));

   name1 = ((FILEINFO *)f1)->name;
   name2 = ((FILEINFO *)f2)->name;

   p1 = strrchr(name1, '.');
   p2 = strrchr(name2, '.');

   if (p1==NULL  &&  p2==NULL)
      return(strcmp(name1,name2));

   if (p1==NULL  &&  p2!=NULL)
      return(-1);
   
   if (p1!=NULL  &&  p2==NULL)
      return(1);
  
   if (strcmp(p1,p2) == 0)
      return(sort_byname(f1,f2));

   return(strcmp(p1,p2));
}


sort_bydate(f1, f2)
void *f1, *f2;
{
   int a;

   if ((a=sort_cmpspec(f1,f2)) != 0)
      return(a);

   if ( ((FILEINFO *)f1)->type == FTYPE_DIR  &&
        ((FILEINFO *)f2)->type == FTYPE_DIR )
      return(sort_byname(f1,f2));

   return( sort_date_cmp( &((FILEINFO *)f1)->fdate,
			  &((FILEINFO *)f2)->fdate ) );
}


sort_none(f1, f2)
void *f1, *f2;
{
   if ( ((FILEINFO *)f1)->pos < ((FILEINFO *)f2)->pos )
      return(-1);
   if ( ((FILEINFO *)f1)->pos > ((FILEINFO *)f2)->pos )
      return(1);
   return(0);
}


sort_date_cmp(d1, d2)
struct tm *d1, *d2;
{
   if (d1->tm_year > d2->tm_year)
      return(-1);
   if (d1->tm_year < d2->tm_year)
      return(1);

   if (d1->tm_mon > d2->tm_mon)
      return(-1);
   if (d1->tm_mon < d2->tm_mon)
      return(1);

   if (d1->tm_mday > d2->tm_mday)
      return(-1);
   if (d1->tm_mday < d2->tm_mday)
      return(1);

   if (d1->tm_hour > d2->tm_hour)
      return(-1);
   if (d1->tm_hour < d2->tm_hour)
      return(1);

   if (d1->tm_min > d2->tm_min)
      return(-1);
   if (d1->tm_min < d2->tm_min)
      return(1);

   return(0);
}


sort_files(pos)
int pos;
{
   if (uc[pos].sorting == SORT_NAME)
      qsort((void *)uc[pos].files, uc[pos].filenum, sizeof(FILEINFO),
	     sort_byname );
   else
   if (uc[pos].sorting == SORT_SIZE)
      qsort((void *)uc[pos].files, uc[pos].filenum, sizeof(FILEINFO),
	     sort_bysize );
   else
   if (uc[pos].sorting == SORT_EXT)
      qsort((void *)uc[pos].files, uc[pos].filenum, sizeof(FILEINFO),
	     sort_byext );
   else
   if (uc[pos].sorting == SORT_DATE)
      qsort((void *)uc[pos].files, uc[pos].filenum, sizeof(FILEINFO),
	     sort_bydate );
   else
   if (uc[pos].sorting == SORT_NONE)
      qsort((void *)uc[pos].files, uc[pos].filenum, sizeof(FILEINFO),
	     sort_none );
}


select_sort(pos)
int pos;
{
   int c, fpos;

   if (uc[pos].showmode == SHOWTREE)
   {
      prompt("Not available","");
      ti_getch();
      return(0);
   }

   prompt("Sort by :  N=Name   S=Size   E=Extension   D=Date   U=Unsorted", ">");
   do
      c = ti_getch();
   while (strchr("nNsSeEuDdU",c)==(char *)NULL);

   if (c=='n'  ||  c=='N')
      uc[pos].sorting = SORT_NAME;
   else
   if (c=='s'  ||  c=='S')
      uc[pos].sorting = SORT_SIZE;
   else
   if (c=='e'  ||  c=='E')
      uc[pos].sorting = SORT_EXT;
   else
   if (c=='d'  ||  c=='D')
      uc[pos].sorting = SORT_DATE;
   else
      uc[pos].sorting = SORT_NONE;

   update_screen(pos);
   return(1);
}


