/* $Header: /usr2/brugere/jbln/uc133/src/RCS/terminfo.c,v 1.1 1995/02/17 22:06:47 jbln Exp $ */

#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <ctype.h>

#include "cfgfile.h"
#include "uc.h"

typedef struct
{
   int code[8];
   int keynum;
} TINFO;
static TINFO *terminfo = NULL;
static int terminfonum = 0;

static char *keynames[] =
   {"up", "down", "left", "right", "pageup", "pagedown", 
    "F1", "F2", "F3", "F4", "F5", "F6", "F7", "F8", "F9", "F10", NULL};
static int keyvalues[] =
   {KEY_UP, KEY_DOWN, KEY_LEFT, KEY_RIGHT, KEY_PPAGE, KEY_NPAGE,
    KEY_F(1), KEY_F(2), KEY_F(3), KEY_F(4), KEY_F(5), 
    KEY_F(6), KEY_F(7), KEY_F(8), KEY_F(9), KEY_F(10) };

static int ti_add_info();

/********************************************************************/

ti_getch()
{
   static int keys[8];
   static int hd=0,tl=0;
   int key;
   int found=0, more;
   int n,m=0;

   if (hd!=tl)
   {
      return(keys[ (tl=(tl+1)%8) ]);
   }

   do
   {
      key = getch();
      hd = (hd+1) % 8;
      keys[hd] = key;
      more = 0;
      for (n=0 ; n<terminfonum ; n++)
      {
	 if (terminfo[n].code[m] == key)
	 {
	    more = 1;
	    if (terminfo[n].code[m+1] == -1)
	    {
	       found = 1;
	       key = terminfo[n].keynum;
	    }
	 }
      }
      m++;
   }
   while (more && !found);

   if (!found)
   {
      return(keys[ (tl=(tl+1)%8) ]);
   }
   hd = tl = 0;

   return(key);
}


ti_setup(cfg)
CFGDATA *cfg;
{
   int n;

   for (n=0 ; n<cfg->datanum ; n++)
      ti_add_info(cfg->data[n].id, cfg->data[n].val);
}


ti_test()
{
   int n;

   printf("Press keys ...\n\r");
   do
   {
      n = ti_getch();
      printf("Key = %d\n\r", n);
   }
   while (n!='q');
}


static ti_add_info(id, val)
char *id, *val;
{
   int key = -1;
   int n, keycode[8];
   char *p = val;

   for (n=0 ; keynames[n]!=NULL ; n++)
      if (strcmp(keynames[n], id) == 0)
	 key = keyvalues[n];

   if (key == -1)
      return(0);

   n=0;
   while (isspace(*p))
      p++;
   while (*p != 0  &&  n<7)
   {
      if (*p == '^')
      {
	 p++;
	 if (*p == '^')
	 {
	    keycode[n++] = '^';
	    p++;
	 }
         else
	 if (*p != 0)
	 {
	    keycode[n++] = toupper(*p) - '@';
	    p++;
	 }
      }
      else
      {
	 keycode[n++] = *(p++);
      }
   }
   keycode[n] = -1;

   if (n == 0)
      return(0);

   if (terminfo == (TINFO *)NULL)
      terminfo = (TINFO *)malloc(sizeof(TINFO));
   else
      terminfo = (TINFO *)realloc(terminfo, sizeof(TINFO)*(terminfonum+1));

   for (n=0 ; n<8 ; n++)
      terminfo[terminfonum].code[n] = keycode[n];
   terminfo[terminfonum].keynum = key;
   terminfonum++;

   return(1);
}

